   import java.awt.Event;
   import java.lang.*;

   import java.applet.*;
   import java.awt.*;
   import java.util.Random;
   import java.math.*;


	// directions:
	// forward  == 1
	// left     == 2
	// backward == 3
	// right    == 4


	// world:
	// never visited (yet)       == 0
	// current position of agent == 1 
	// visited place				  == 2


   public class lclfinal extends Applet {
   	// specifies the number of agent in the population
   	// default = 1000
      int population_size=500;
   
   	// specifies the number of steps the agents perform
   	// in order to determine their fitness
   	// default = 200
      int step_num = 100;
   
   	// specifies the number of generations the simulation runs
   	// default = 200
      int generation_num = 100;
   
   	// specifies after which generation a new fittest agent
   	// should be shown in detail i.e. the agents walks
   	// step by step
   	// default = 50
      int show_movement = 50;
   
   	// specifies the probability of mutation for every
   	// single gene when doing crossover. one individual
   	// in encoded in 42 genes therefore a mutation
   	// rate of 1/42 equals to one mutation per crossover.
   	// default = 0.05
      double mutation_rate = 0.05;
   
      // fitness function parameters:
      // cp_weight is the weight for the exploration component,
      // cd_weight for the localization component
      // default = 0.5
      double cp_weight = 0.5;
      double cd_weight = 1 - cp_weight; 
   
   
   
      int generation;
      int step = 1;
      Random rnd= new Random();
      double distance;
      double max_distance;
      double visited;
      double cp;
      double cd;
      double[] fitness = new double[population_size];
   
   
      double max_fitness = 0;
   
      double max_fitness_gen = 0;
      double[] max_fitness_gen_array = new double[generation_num];
   
      double avg_fitness_gen = 0;
      double[] avg_fitness_gen_array = new double[generation_num];
   
      double phi;
      double r;
   
      double[][] anns = new double[population_size][6*(2+1)+4*(6)];
      double[] fittest_brain = new double[6*(2+1)+4*(6)];
      int agent_id = 0;
   
      int[][] world = new int[49][49];
   
   
      int current_x;
      int current_y;
      int current_dir;
      Color gray = new Color(180,180,180);
      Color lightgray = new Color(220,220,220);
      Color white = new Color(255,255,255);
      Color center = new Color(0,255,0);
      Color black = new Color(0,0,0);
      Color agent = new Color(0,0,255);
      Color agenthead = new Color(255,0,255);
   
      public void start() {
         this.resize(740,510);
         current_x=24;
         current_y=24;
         current_dir=1;
         world[current_x][current_y]=1;
      }
   
      public void init() {
      
         int y;
         int x;
         for (x=0;x<world.length;x++) {
            for (y=0;y<world[1].length;y++) {
               world[x][y]=0;
            }
         }
         int agent_id;
         int index;
      
         for (agent_id=0;agent_id<anns.length;agent_id++) {
            for (index=0;index<anns[1].length;index++) {
               anns[agent_id][index]=rnd.nextDouble();
               // System.out.println(anns[agent_id][index]);
            }
         }
      }
   
   
      public void paint(Graphics g) {
      
         for (generation = 0; generation<generation_num; generation++) {
            max_fitness_gen=0;
         
            for (agent_id = 0; agent_id<population_size; agent_id++) {
            
            
               reset_agent();
            
               for (step = 1;step<step_num;step++) {
               
                  move();
               
               
               }
               calc_fitness();
            
               if (fitness[agent_id] > max_fitness_gen) {
                  max_fitness_gen=fitness[agent_id];
               
                  if (max_fitness_gen > max_fitness) {
                     max_fitness=max_fitness_gen;
                     fittest_brain = (double[])anns[agent_id].clone();
                     realpaint(g);
                     statistics(g);
                  
                     if (generation>show_movement) {
                     
                        show_fittest_agent(g);
                     
                     }
                  
                  }
               
               
               
               }
            
            
            }
         
         
         
            max_fitness_gen_array[generation] = max_fitness_gen;
            avg_fitness_gen_array[generation] = avg_fitness_gen;
         
         
           // System.out.println("gen: "+generation+" max.fit.: "+max_fitness_gen+" max_fit_overall: "+max_fitness);
            evolution();
         
            reset_agent();
            anns[0] = fittest_brain;
            agent_id=0;
         
            for (step = 1;step<step_num;step++) {
               move();
            
            }
            calc_fitness();
            realpaint(g);
         
            statistics(g);
         }
      
         while (agent_id>=0) {
            show_fittest_agent(g);
         }
      
      }
   
   
   
      public void statistics(Graphics g) {
         g.setColor(white);   
         g.fillRect(500,240,generation_num,250);
      	
      	g.setColor(black);   
         g.drawRect(500,240,generation_num,250);
      
         for (int i=0; i<generation_num; i++) {
            if (max_fitness_gen_array[i]>0.0) {
               g.setColor(black); 
               g.fillRect(500+i,(490-(int)(max_fitness_gen_array[i]*250)),2,2);
               g.setColor(agenthead);   
               g.fillRect(500+i,(490-(int)(avg_fitness_gen_array[i]*250)),2,2);
            }
         }
      
         g.setColor(white);
         g.fillRect(500,130,200,90);
      
         g.setColor(black);   
         g.drawString("about the simulation:",500,155);
         g.drawString("gen       ="+generation,500,170);
         g.drawString("#ofsteps  ="+step,500,185);
         g.drawString("maxfitness="+max_fitness,500,200);
         g.drawString("avgfit="+avg_fitness_gen,500,215);
      
      
      
      }
   
   
      public void show_fittest_agent(Graphics g) {
      
         // show fittest agent
         reset_agent();
         anns[0] = fittest_brain;
         agent_id=0;
         realpaint(g);
         statistics(g);
      
         for (step = 1;step<step_num;step++) {
            move();
         
         }
         calc_fitness();
         show_agent_movement(g,true);
         reset_agent();
         anns[0] = fittest_brain;
         agent_id=0;
         for (step = 1;step<step_num;step++) {
            move();
            show_agent_movement(g,false);
         }
      }
   
   
      public void show_agent_movement(Graphics g, boolean mode) {
      
      
      
         int y;
         int x;
      
         for (x=0;x<world.length;x++) {
            for (y=0;y<world[1].length;y++) {
              //  if (world[x][y]==0){
            //                   g.setColor(white);
            //                   g.fillRect(x*10,y*10,10,10);
            //                   g.setColor(black);
            //                   g.drawRect(x*10,y*10,10,10);
            //                }
               if (world[x][y]==2){
               
                  if (mode)
                     g.setColor(lightgray);
                  else
                     g.setColor(gray);
               
                  g.fillRect(x*10,y*10,10,10);
                  g.setColor(black);
                  g.drawRect(x*10,y*10,10,10);
               }
               if (world[x][y]==1) {
                  g.setColor(agent);
                  g.fillRect(x*10,y*10,10,10);
                  g.setColor(black);
                  g.drawRect(x*10,y*10,10,10);
               
               	//draw agents direction
                  g.setColor(agenthead);
                  if (current_dir==1) 
                     g.fillRect(x*10,y*10,10,3);
               
                  if (current_dir==2)
                     g.fillRect(x*10+7,y*10,3,10);
               
                  if (current_dir==3) 
                     g.fillRect(x*10,y*10+8,10,3);
               
                  if (current_dir==4)
                     g.fillRect(x*10,y*10,4,10);
               
               }	
               g.setColor(center);
               g.fillRect(24*10,24*10,10,10);
               g.setColor(black);
               g.drawRect(x*10,y*10,10,10);
            }
         }
      
         if (mode) {
            g.setColor(white);
            g.fillRect(500,1,200,130);
            g.setColor(black);
            g.drawString("about this agent:",500,20);
            g.drawString("agent_id  ="+agent_id,500,35);
            g.drawString("max_radius="+max_distance,500,50);
            g.drawString("visited   ="+visited,500,65);
            g.drawString("cp        ="+cp,500,80);
            g.drawString("cd        ="+cd,500,95);
            g.drawString("fitness   ="+fitness[agent_id],500,110);
         }
      
      }
   
   
      public void realpaint(Graphics g) {
      
         int y;
         int x;
      
         for (x=0;x<world.length;x++) {
            for (y=0;y<world[1].length;y++) {
               if (world[x][y]==0){
                  g.setColor(white);
                  g.fillRect(x*10,y*10,10,10);
                  g.setColor(black);
                  g.drawRect(x*10,y*10,10,10);
               }
               if (world[x][y]==2){
                  g.setColor(gray);
                  g.fillRect(x*10,y*10,10,10);
                  g.setColor(black);
                  g.drawRect(x*10,y*10,10,10);
               }
               if (world[x][y]==1){
                  g.setColor(agent);
                  g.fillRect(x*10,y*10,10,10);
                  g.setColor(black);
                  g.drawRect(x*10,y*10,10,10);
               
               	//draw agents direction
                  g.setColor(agenthead);
                  if (current_dir==1) 
                     g.fillRect(x*10,y*10,10,3);
               
                  if (current_dir==2)
                     g.fillRect(x*10+7,y*10,3,10);
               
                  if (current_dir==3) 
                     g.fillRect(x*10,y*10+8,10,3);
               
                  if (current_dir==4)
                     g.fillRect(x*10,y*10,4,10);
               
               }	
               g.setColor(center);
               g.fillRect(24*10,24*10,10,10);
               g.setColor(black);
               g.drawRect(x*10,y*10,10,10);
            }
         }
      
         g.setColor(white);
         g.fillRect(500,1,200,130);
      
         g.setColor(black);
         g.drawString("about this agent:",500,20);
         g.drawString("agent_id  ="+agent_id,500,35);
         g.drawString("max_radius="+max_distance,500,50);
         g.drawString("visited   ="+visited,500,65);
         g.drawString("cp        ="+cp,500,80);
         g.drawString("cd        ="+cd,500,95);
         g.drawString("fitness   ="+fitness[agent_id],500,110);
      
      
      }
   
   
      public void evolution() {
      
         double fit_temp;
         int agent_temp = 0;
         int[] select = new int[population_size];
         int select_counter = 0;
      
      
      
         for (int select_agent = 0; select_agent < (population_size/2); select_agent++) {
            fit_temp = 0;
            avg_fitness_gen=0;
            for (agent_id = 0; agent_id < population_size; agent_id++) {
               avg_fitness_gen=avg_fitness_gen+fitness[agent_id];
               if ((fitness[agent_id] > fit_temp) && (select[agent_id] == 0)) {//|| ((rnd.nextDouble() < 0.01) && (select[agent_id] == 0))){
                  fit_temp = fitness[agent_id];
                  agent_temp = agent_id;
               }
            
            }
            //System.out.println(agent_temp+"  "+fitness[agent_temp]);
            select[agent_temp]=1;
         }
      
         avg_fitness_gen=avg_fitness_gen/population_size;
      
         int selected1;
         int selected2;
         int target1;
         int target2;
         int crossoverpoint;
      
      
         for (int select_agent = 0; select_agent < (population_size/4-1); select_agent++) {
         
            selected1=0;
            selected2=0;
            target1=0;
            target2=0;
         
            agent_id=0;
            while (selected1 == 0) {
               if (select[agent_id] == 1) {
                  select[agent_id] = 2;
                  selected1=agent_id;
               }
               agent_id++;
            }
         
            agent_id=0;
            while (selected2 == 0) {
               if (select[agent_id] == 1) {
                  select[agent_id] = 2;
                  selected2=agent_id;
               }
               agent_id++;
            }
         
            agent_id=0;
            while (target1 == 0) {
               if (select[agent_id] == 0) {
                  select[agent_id] = 2;
                  target1=agent_id;
               }
               agent_id++;
            }
         
            agent_id=0;
            while (target2 == 0) {
               if (select[agent_id] == 0) {
                  select[agent_id] = 2;
                  target2=agent_id;
               }
               agent_id++;
            }
         
            int ann_index;
         
         
         //crossover selected1 & selected2 to target1 
            crossoverpoint = (int)(rnd.nextFloat()*40+1);
            for (ann_index = 0; ann_index < 42; ann_index++) {
               if (rnd.nextDouble()>mutation_rate) {
               //do crossover
                  if (ann_index < crossoverpoint) {
                     anns[target1][ann_index]=anns[selected1][ann_index];
                  }
                  else{
                     anns[target1][ann_index]=anns[selected2][ann_index];
                  }
               }
               else {
               //mutate
                  anns[target1][ann_index]=anns[target1][ann_index]+0.5;
                  if (anns[target1][ann_index]>1.0)
                     anns[target1][ann_index]=anns[target1][ann_index]-0.9;
               }
            }
         
                  //crossover selected1 & selected2 to target2 
            crossoverpoint = (int)(rnd.nextFloat()*40+1);
            for (ann_index = 0; ann_index < 42; ann_index++) {
               if (rnd.nextDouble()>mutation_rate) {
               //do crossover
                  if (ann_index < crossoverpoint) {                
                     anns[target2][ann_index]=anns[selected1][ann_index];
                  }
                  else{
                     anns[target2][ann_index]=anns[selected2][ann_index];
                  }
               }
               else {
               //mutate
                  anns[target2][ann_index]=anns[target2][ann_index]+0.5;
                  if (anns[target2][ann_index]>1.0)
                     anns[target2][ann_index]=anns[target2][ann_index]-0.9;
               
               }
            }
         
         
         }
      
      
      
      }
   
      public void reset_agent() {
      
         current_x=24;
         current_y=24;
         current_dir=1;
      
         int y;
         int x;
         for (x=0;x<world.length;x++) {
            for (y=0;y<world[1].length;y++) {
               world[x][y]=0;
            }
         }
         world[current_x][current_y]=1;
      
      }
      public void move() {
      
      
         //System.out.println("move["+agent_id+"]");
         int dir = calc();
         current_dir = dir + (current_dir-1);
         if (current_dir > 4)
            current_dir=current_dir -4;
      
      
         world[current_x][current_y]=2;
         if ((current_dir==1) && (current_y-1>=0)) 
            current_y=current_y-1;
      
         if ((current_dir==2) && (current_x+1<=48))
            current_x=current_x+1;
      
         if ((current_dir==3) && (current_y+1<=48))
            current_y=current_y+1;
      
         if ((current_dir==4) && (current_x-1>=0))
            current_x=current_x-1;
      
         world[current_x][current_y]=1;
      
         distance = Math.sqrt((double)(Math.pow(current_x-24,2)+Math.pow(current_y-24,2)));
      
      	//calc max_distance
      
      
      
      
      }
   
      public void calc_fitness() {
      
         double temp = 0.0;
         max_distance=0;
         visited=0;
         int y;
         int x;
         for (x=0;x<world.length;x++) {
            for (y=0;y<world[1].length;y++) {
               if ((world[x][y]==1) || (world[x][y]==2)) {
                  temp= Math.sqrt((double)(Math.pow(x-24,2)+Math.pow(y-24,2)));
                  visited++;
               }
               if (temp>=max_distance)
                  max_distance=temp;
            }
         }
         cp=visited/(double)step;
         double min_cd = Math.sqrt(visited/Math.PI)-1;
         cd=min_cd/max_distance;
         fitness[agent_id]=cp_weight*cp+cd_weight*cd; 
      }
   
      public int calc() {
         int calc_value = 1;
         double[] hidden = new double[6];
         double[] output = new double[4];
      
      // calculate r
         r = Math.sqrt((double)(Math.pow(current_x-24,2)+Math.pow(current_y-24,2)))/24;
      
      //calculate phi
         if (current_dir==1) 
            phi=Math.atan2((double)(24-current_y),(double)(24-current_x));
      
         if (current_dir==2)
            phi=Math.atan2((double)(24-current_y),(double)(-24-current_x));
      
         if (current_dir==3) 
            phi=Math.atan2((double)(-24-current_y),(double)(-24-current_x));
      
         if (current_dir==4)
            phi=Math.atan2((double)(24-current_y),(double)(-24-current_x));
      
         phi=((phi/Math.PI)/2.0+1.0/2.2);
      
         for (int i=0;i<6;i++) {
            hidden[i]=phi*anns[agent_id][1+i*3]+r*anns[agent_id][2+i*3];
            if (hidden[i] < anns[agent_id][0+i*3])
               hidden[i] = 0;
            else
               hidden[i] = 1.0;
         }	
         int j;
      
         for (int i=0;i<4;i++) {
            output[i]=0;
            for (j=0;j<6;j++){
               output[i]=output[i]+hidden[j]*anns[agent_id][18+i*6+j];
            }
         }	
         double max_output=0;
         for (int i=0;i<4;i++) {
            if (output[i]>max_output) {
               max_output = output[i];
               calc_value = i+1;
            }
         }	
         return(calc_value);
      
      }
   }